//http://www.webpasties.com/xmlHttpRequest/xmlHttpRequest_tutorial_1.html
function getHTTPObject() {

  var xmlhttp;

  /*@cc_on

  @if (@_jscript_version >= 5)

    try {

      xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");

    } catch (e) {

      try {

        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

      } catch (E) {

        xmlhttp = false;

      }

    }

  @else

  xmlhttp = false;

  @end @*/

  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {

    try {

      xmlhttp = new XMLHttpRequest();

    } catch (e) {

      xmlhttp = false;

    }

  }

  return xmlhttp;

}


//indexes in stat array of various interesting fields 
var PRISONERS = 4; //and 5
var REQUEST_PENDING = 7;
var REQUEST_GRANT = 8;
var REQUEST_DENY = 9;
var REQUEST_GAMESTATE = 6;
var BOARD = 10;

password='';   //user password
gpassword=''; //game password
http = getHTTPObject();
httpb = getHTTPObject();
movex=-1;   //last move 
movey=-1;   //last move
move=-1;    //move number
size = 0;  //board size
gameOver = false;
deadRemoved = 0; //number of dead stones removed by opponent at end of game
gameName='';
color=0;  //our color, 0=black 1=white
uid=0; //incremented each gotBoard call
pending = 0; //true if we made a request which is still pending (value of request field)

//return true if position is a key position
function isKeyPoint(size, x, y) {
    halfsz = parseInt(size/2);
    if (size<=11) 
	corn = 2;
    else
	corn = 3;
    
    if ( (x==corn || x==size-corn-1 || x==halfsz) && (y==corn || y==size-corn-1 || y==halfsz))
	    return true;
    return false;
    
}

//redraw the board
function updateBoard(board, lxs, lys) {
    //alert("board "+board);
    lx = parseInt(lxs);
    ly = parseInt(lys);
    //alert(lx+" "+ly);
    if (board.length != size*size) {
	alert("invalid board "+board.length+"  "+board);
	return;
    }
    for (x=0;x<size;x++) {
	for (y=0;y<size;y++) {
	    val = board.substring(x+y*size,x+y*size+1); //board[y+x*size];
	    mod='';
	    if (y==0)
		mod = mod+'n';
	    if (y==size-1) 
		mod = mod+'s';
	    if (x==0)
		mod = mod+'w';
	    if (x==size-1)
		mod = mod+"e";
	    if (y==ly && x==lx)
		mod = mod+'l';

	    if (val=='0' && isKeyPoint(size, x, y))
		mod = 'c';
	    document.getElementById("i"+x+"-"+y).src="tile"+val+mod+".png";
	}
	
    }		
}



function checkTimeout(id) {
    if (uid == id) {
	getBoard(0);
    }
}

function getBoard(init) {
    http.onreadystatechange = null;
    http.abort();
    mv = move+1;
    if (init) {
	mv = -1;
    }
    req='getboard.php?name='+gameName+'&password='+gpassword+'&color='+color+'&move='+mv+'&timeout=20';
    if ( ((move+color)%2)==0 && pending) {
	req += '&getreply=1';
    }
    
    if ( ((move+color+1)%2)==0) {
	req += '&getrequest='+pending;
    }
    if (gameOver) {
	req += '&prisoners='+deadRemoved;
    }
    http.onreadystatechange = gotBoard;
    http.open("GET", req, !init);    
    http.send(null);
    //alert('gb '+http.readyState);
    if (init || (http.readyState==4))
	gotBoard();
    setTimeout("checkTimeout("+uid+")",30000);
}


function boardClick(x,y) {
    if ((move+color)%2 && (!gameOver)) {
	alert("not your turn");
	return;
    }
    http.abort();
    if (!http)
	alert('pas cool');
    //make the move
    movex = x;
    movey = y;
    // We create the HTTP Object
    req='makemove.php?name='+gameName+'&password='+password+'&color='+color+'&x='+x+'&y='+y;
    if (gameOver) {
	req+='&removedead=1';
    }
    //alert(req);
    http.open("GET", req, true);
    http.onreadystatechange = makemove;
    http.send(null);
   
}


function initBoard(sz,n,c,mv, pass, gpass) {
    password = pass;
    gpassword = gpass;
    size = sz;
    gameName = n;
    color=c;
    move = mv;
    for (x=0;x<size;x++) {
	for (y=0;y<size;y++) {
	    mod='';
	    if (y==0)
		mod = mod+'n';
	    if (y==size-1) 
		mod = mod+'s';
	    if (x==0)
		mod = mod+'w';
	    if (x==size-1)
		mod = mod+"e";
	    document.getElementById("i"+x+"-"+y).src="tile0"+mod+".png";
	    //document.getElementById("i"+x+"-"+y).onMouseDownk="boardClick("+x+","+y+");";
	}
	
    }
    getBoard(1);
   
}




function updateInfos(datas) {
    pending = parseInt(datas[REQUEST_PENDING]);
    move = parseInt(datas[1]);
    turn = '';
    if (datas[REQUEST_GAMESTATE]=='o') {
	turn = 'Game over, click on dead group of stones of YOUR color to remove them';
	gameOver = true;
    }
    else  if ( ((move+color)%2)==0) {
	turn = 'Your turn';
    }
    else {
	turn = " Waiting opponent's move";
    }
    document.getElementById('info1').innerHTML="Move "+move+'    '+turn;

    if ( ((move+color)%2)==0) {	
	i5= '';
	if (datas[REQUEST_GRANT] & 1) {	
	    i5 +='<font color="green">Request Granted</font>';	
	}
	if (datas[REQUEST_DENY] & 1) {
	    i5+='<font color="red">Request Denied</font>';		 
	}
	if (datas[REQUEST_PENDING] & 1) {
	    i5+='Request pending';
	}
	document.getElementById('info5').innerHTML =i5;
    }
    else {
	if (datas[REQUEST_PENDING] & 1) {
	    document.getElementById('info5').innerHTML='Oponent requested to go back two moves. '+
		'You must <font color="green"><a href="#" onclick="requestAnwser(1,1)">Grant</a></font>'+
		'or <font color="red"><a href="#" onclick="requestAnwser(1,0)">Deny</a></font> this request'
	}
    }
    document.getElementById('info2').innerHTML="Last Move : "+(parseInt(datas[2])+1)+" , "+(parseInt(datas[3])+1);
    document.getElementById('info3').innerHTML="Prisoners:  Black "+datas[4]+"    White "+datas[5];

    
   deadRemoved = datas[PRISONERS+((color)%2)];
    
}




function gotBoard() {	
    //alert(http.readyState);
    if (http.readyState == 4) {
	//alert(http.readyState);
	//alert('player moved:'+http.responseText);
	uid++;
	results = http.responseText;
	datas = results.split(' ');
	if (datas[0]!="OK") {
	    if (results.substring('TIMEOUT') != -1) {
		//alert('request timeout');
		setTimeout("getBoard(0)",500);
		return;
	    }
	    alert("unexpected "+results);
	}
	else {
	    updateInfos(datas);
	    updateBoard(datas[BOARD], datas[2], datas[3]);
	}
	if ( ((move+color)%2) == 1 || pending || gameOver) {
	    setTimeout("getBoard(0)",500);
	    
	}
    }
}

function makemove() {
    if (http.readyState == 4) {
	//alert(http.readyState);
	//alert(http.responseText);
	results = http.responseText;	
	datas = results.split(' ');
	if (datas[0]!="OK") {
	    alert("Invalid move:"+results);
	}
	else {
	    updateInfos(datas);
	    updateBoard(datas[BOARD], datas[2], datas[3]);
	    //alert('made our move '+move);
	    getBoard(0);
	}

    }
}



function gotScore() {
    if (httpb.readyState == 4) {
	//alert(http.responseText);
	results = httpb.responseText;	
	datas = results.split(' ');
	if (datas[0]!="OK") {
	    alert("Invalid response:"+results);
	}
	else {
	    sc = 'Territory: Black '+datas[1]
		+'&nbsp&nbsp&nbsp&nbspWhite '+datas[2]+'&nbsp&nbsp&nbsp&nbspUncertain '
		+ datas[3];
	    if (parseInt(datas[4]) == 1) {
		sc += '&nbsp&nbsp&nbs Final';
	    }
	    document.getElementById('info4').innerHTML=sc;
	}
    }
}

function gotReply() {
    if (httpb.readyState == 4) {
	results = httpb.responseText;	
	datas = results.split(' ');
	if (datas[0]!="OK") {
	    alert("Invalid response:"+results);
	}
	else {
	    //update display
	    if ((color%2)==0) {
		document.getElementById('info5').innerHTML='Request transmitted...';
	    }
	    else {
		document.getElementById('info5').innerHTML='Request anwsered...';
	    }
	    
	}
    }
}

function getScore() {
    req='score.php?name='+gameName+'&password='+password+'&color='+color;
    httpb.onreadystatechange = gotScore;
    httpb.open("GET", req, true);    
    httpb.send(null);
}


function requestAnwser(reqid,response) {
    req = 'request.php?name='+gameName+'&password='+password+'&color='+color+'&request=REQUEST';
    if (response) {
	req += 'GRANT ';
    }
    else {
	req += 'DENY ';
    }
    req += reqid;

    httpb.onreadystatechange = gotReply;
    httpb.open("GET", req, true);    
    httpb.send(null);
}

function requestBack() {
    if ((move+color)%2) {
	alert("not your turn");
	return;
    }
    pending = 1;
    req = 'request.php?name='+gameName+'&password='+password+'&color='+color+'&request=REQUEST 1';
    httpb.onreadystatechange = gotReply;
    httpb.open("GET", req, true);    
    httpb.send(null);
    getBoard(0); //start listening
}
