/** basetype.h
//	Base data types to be used for portability.
*/
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2001
//	
// Contributor(s):
//
//==========================================================================


#ifndef INC_BASETYPE
#define INC_BASETYPE	1


// The usual suspects in Microsoft style:

#ifndef USHORT
typedef 	unsigned short		USHORT;
#endif

#ifndef SHORT
typedef 	short				SHORT;
#endif

#ifndef UCHAR
typedef 	unsigned char 		UCHAR;
#endif

#ifndef BYTE
typedef 	unsigned char 		BYTE;
#endif

#ifndef	CHAR
typedef 	char				CHAR;
#endif

#ifndef	UINT
typedef 	unsigned int		UINT;
#endif

#ifndef INT
typedef 	int         		INT;
#endif



//! Logical types:

#define 	TRUE				1
#define 	FALSE				0

#ifndef BOOL
typedef 	int					BOOL;
#endif



//! sized & signed types:

typedef 	unsigned char 		U8BIT;	//! unsigned 8 bits
typedef 	char				S8BIT;	//! signed 8 bits
typedef 	unsigned short		U16BIT;	//! unsigned 16 bits
typedef 	short				S16BIT;	//! signed 16 bits
typedef 	unsigned int		U32BIT;	//! unsigned 32 bits
typedef 	int					S32BIT;	//! signed 32 bits



//! fastest type for this machine where size doesn't matter:
typedef	U32BIT				UFASTEST;	//! fastest unsigned type
typedef	S32BIT				SFASTEST;	//! fastest signed type


#endif	// INC_BASETYPE
