//! bdspace.cpp
//!	board optimized for space
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2002
// 
// Contributor(s):
//
//==========================================================================



#include "bdspace.h"


// ****************************************************************
//		Board_OptSpace Class functions
// ****************************************************************
//Board_OptSpace::Board_OptSpace( U32BIT bdsize )
//{
//	Assert( bdsize < MAXBOARDSIZE );
//	memset( board, PC_None, MAXBOARDSIZE*MAXBOARDSIZE );
//}

Board_OptSpace::Board_OptSpace()
{
	memset( board, PC_None, MAXBOARDSIZE*MAXBOARDSIZE );
}

Board_OptSpace::~Board_OptSpace()
{
}

//U32BIT Board_OptSpace::GetBoardSize()
//{
//	return _bdsize;
//}
//
//void Board_OptSpace::SetBoardSize(U32BIT bdsize)
//{
//	Assert( bdsize < MAXBOARDSIZE );
//	_bdsize = bdsize;
//}

//! row & col are zero based!!!
void Board_OptSpace::SetColorAtRowCol( UINT row, UINT col, PieceColor color)
{
	Assert( row >= 0 && row <= 18 && col >= 0 && col <= 18 );
	//wtf?? Assert( color != PC_None);

#if 0
	UINT BytesIntoBoard;  // Offset into board by bytes.
	UINT BitsIntoByte;    // Offset into a board byte for the cell.

		// right-shift instead of divide by BITS_PER_BYTE because it's faster.
	BytesIntoBoard = ( ( (row * BITS_PER_ROW) + (BITS_PER_CELL * col) ) >>3);
	BitsIntoByte   = ( (col % CELLS_PER_BYTE) * BITS_PER_CELL );
	board[ BytesIntoBoard ] &= ~(MASK << BitsIntoByte);	// turn off all bits
	board[ BytesIntoBoard ] |= (color << BitsIntoByte);	// or in the the new bits.
#endif
//	board[(row * (MAXBOARDSIZE-1)) + col] = (char)color;
	board[row][col] = color;
}


//! row & col are zero based!!!
void Board_OptSpace::GetColorAtRowCol( UINT row, UINT col, PieceColor *color)
{
	Assert( row >= 0 && row <= MAXBOARDSIZE && col >= 0 && col <= MAXBOARDSIZE );

#if 0
	UINT BytesIntoBoard;  // Offset into board by bytes.
	UINT BitsIntoByte;    // Offset into a board byte for the cell.
	unsigned char byte;

		// right-shift instead of divide by BITS_PER_BYTE because it's faster.
	BytesIntoBoard = ( ( (row * BITS_PER_COL) + (BITS_PER_CELL * col) ) >>3);
	BitsIntoByte   = ( (col % CELLS_PER_BYTE) * BITS_PER_CELL );

	byte = board[ BytesIntoBoard ] & (MASK << BitsIntoByte);
		// shift to get the value
	*color = (byte >> BitsIntoByte);
#endif
//	*color = board[(row * (MAXBOARDSIZE-1)) + col];
	*color = board[row][col];
//	Assert( *color != PC_None);
}


