//! bdspace.h
//!		A board, optimized for minimal space.
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2002
// 
// Contributor(s):
//
//==========================================================================


#ifndef INC_BDSPACE
#define INC_BDSPACE

#include "piece.h"

// *************************************************************************
// Defines
// *************************************************************************


#define MAXBOARDSIZE	19		//! size of board these games are for

#define BITS_PER_CELL	2		//! minimum bits to represent a stone
#define TTLBITS			(BITS_PER_CELL * MAXBOARDSIZE * MAXBOARDSIZE)
#define TTLBYTES		(1+(TTLBITS / 8))

#define BITS_PER_ROW	(MAXBOARDSIZE * BITS_PER_CELL)
#define BITS_PER_COL    (MAXBOARDSIZE * BITS_PER_CELL)
#define BITS_PER_BYTE	8	// >> 3
#define CELLS_PER_BYTE  (BITS_PER_BYTE / BITS_PER_CELL)
#define MASK			(BITS_PER_CELL+1)

class Board_OptSpace
{
public:
	Board_OptSpace();
//	Board_OptSpace( U32BIT bdsize);
	~Board_OptSpace();


public:
	typedef U8BIT BoardMem;			//! board optimized for space.
	typedef BoardMem * PBoardMem;	//! board optimized for space.

		//! row & col are zero based!!!
	void	GetColorAtRowCol( UINT row, UINT col, PieceColor *color);
	void	SetColorAtRowCol( UINT row, UINT col, PieceColor color);

//	U32BIT	GetBoardSize();
//	void	SetBoardSize( U32BIT bdsize );

private:

//	BoardMem board[ TTLBYTES ];	//! board optimized for space.
	BoardMem board[MAXBOARDSIZE][MAXBOARDSIZE];	//! this is for debugging
//	U32BIT	_bdsize;
};


#endif   // INC_BDSPACE
