/** fatal.cpp
//	Support for fatal and assertion errors.
*/
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2001
//	
// Contributor(s):
//	Jeffrey Greenberg	v2		1997 orig
//
//==========================================================================


// #include <process.h>	// for exit

#include "deps.h"	// for exit
#include "fatal.h"
//#include "os.h"
void Trap( void )
{
// This is OS/processor specific.
        char *p = (char *)0;
        *p = 5;
}

//! Die and exit with the error.
void Fatal( ErrId id )
{
     Trap();
   exit( id );
}

//! Die and exit with the error, plus
//! Parameters are unused but on the stack for inspection!
void Fatal( ErrId id, char *comment, char *filename, const int lineno )
{
  Trap();
   exit( id );
}

//! Out of memory exit
void NoMoreMem()
{
  Trap();
	exit(ERR_NOMEMORY);
}
