/** fatal.h
 * 	Interface for all forms of fatal exit.
*/
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2001
//	
// Contributor(s):
//	Jeffrey Greenberg	v1		1996 orig
//	Jeffrey Greenberg	v2		1997
//	Jeffrey Greenberg	v3		1999
//	Jeffrey Greenberg	v4		2000
//	Jeffrey Greenberg	v4.2	2000
//	Jeffrey Greenberg	v5.0	2001
//
//==========================================================================


#ifndef INC_ERR
#define INC_ERR	1


//! basic errors
enum ErrId {
	ERR_NONE = 0,
	ERR_PANIC,
	ERR_ASSERT,
	ERR_NOMEMORY,
	ERR_UNKNOWN,
	ERR_UNSUPPORTED
};

// These two trap...
void Fatal( ErrId id );
void Fatal( ErrId id, char *comment, char *filename, const int lineno );

//! Our assert traps which is handier.
// #define Assert(exp)	if(!(exp)) {Fatal( ERR_ASSERT, #exp, __FILE__, __LINE__ );} else {;}
#define Assert(exp) (void)( (exp) || (Fatal(ERR_ASSERT, #exp, __FILE__, __LINE__), 0) )

void NoMoreMem();

#endif	// INC_ERR
