#include  "iostd.h"


IOStd::IOStd() {
  _pLogFile = stderr;
}


void IOStd::Fatal( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        fprintf( _pLogFile, "Fatal: ");
        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
	//      Trap();
        exit(1);
}


void IOStd::Error( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        fprintf( _pLogFile, "Error: ");
        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
}

void IOStd::Log( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
}

void IOStd::Log( BOOL bDebug, char *fmt, ... )
{
        va_list marker;

        if( !bDebug )
           return;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        fprintf( _pLogFile, "Diag: ");
        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
}



void IOStd::InfoBuf(char * Buffer)
{
        fprintf(stdout, Buffer);
}

void IOStd::Info( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */
	/*
        vfprintf( stdout, fmt, marker );
        fprintf( stdout, "\n");
        fflush(stdout);
	*/
        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
}

void IOStd::InfoNoCrLf( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        vfprintf( stdout, fmt, marker );
        fflush(stdout);

        vfprintf( _pLogFile, fmt, marker );
        fflush( _pLogFile );

        va_end( marker );   /* Reset variable arguments.         */
}



void IOStd::Prob( char *fmt, ... )
{
        va_list marker;

        va_start( marker, fmt );  /* Initialize variable arguments. */

        vfprintf( stdout, fmt, marker );
        fprintf( stdout, "\n");
        fflush(stdout);

        vfprintf( _pLogFile, fmt, marker );
        fprintf( _pLogFile, "\n");

        va_end( marker );   /* Reset variable arguments.         */
}
