//! move.cpp
//!	A move is a triplet of a MoveType, a position, and a PieceColor.
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2002
// 
// Contributor(s):
//
//==========================================================================


#include "move.h"

// ***************************************
Move::Move( const MoveType mt, const PieceColor pc, const Coord row, const Coord col )
	: Piece( pc, row, col )
{
	_mt = mt;
}
 
Move::Move( const Move &m )
	: Piece( m.GetColor(), m.GetRow(), m.GetCol() )
{
	_mt = m._mt;
}
 
Move::Move()
	: Piece( PC_None, 0, 0 )
{
	_mt = MT_None;
}

Move::~Move()
{
}
