//! piece.cpp
//!	implementation of a Piece: a pairing of Pt, point, with a PieceColor.
//
// The contents of this file are subject to
//	the OpenGo Public License Version 2.0 (the "License"); you may not
//	use this file except in compliance with the License. You may obtain
//	a copy of the License at http://www.inventivity.com/OpenGo
//
// Software distributed under the License is distributed on an "AS IS" basis,
//	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
//	for the specific language governing rights and limitations under
//	the License.
// 
// Copyright:
//	Jeffrey Greenberg	copyright (c) 1996-2002
// 
// Contributor(s):
//
//==========================================================================


#include "piece.h"

Piece::Piece( const PieceColor pc, const Coord row, const Coord col) :
	Pt( row, col)
{
	_pc = pc;
}

Piece::Piece() :
	Pt( 0, 0)
{
	_pc = PC_None;
}

Piece::~Piece()
{
}

//Piece::Piece(Piece &p) :
//	Pt( p )
//{
//	_pc = p.GetColor();
//}

Piece::Piece(const Piece &p) :
	Pt( p )
{
	_pc = p.GetColor();
}


ostream & operator << ( ostream & os, const PieceColor pc )
{
	if( pc == PC_Black )
		os << "Black";
	else
	if( pc == PC_White )
		os << "White";
	else
		os << "unknown color";

	return os;
}
