#ifndef LOCKABLE_H
#define LOCKABLE_H
#include <pthread.h>
typedef pthread_mutex_t Lock;
inline void initLock(Lock &l) {
  pthread_mutex_init(&l,0);
}
inline void lockLock(Lock &l) {
  pthread_mutex_lock(&l);
}

inline void lockUnlock(Lock &l) {
  pthread_mutex_unlock(&l);
}

inline void deleteLock(Lock &l) {
  pthread_mutex_destroy(&l);
}
class Lockable {
 public:
  Lockable() { initLock(_lock);}
  ~Lockable() { deleteLock(_lock);}
  void lock() {lockLock(_lock);}
  void unlock() {lockUnlock(_lock);}

 private:
  Lock _lock;
};


#endif
